#!/usr/bin/perl -w

require 'me26_ioctl.ph';

printf("MAGIC 0x%x\n", &ME26_IOC_MAGIC() );
printf("EXTTIMER 0x%x\n", &ME26_IOCEXTTIMER() );
printf("INTTIMER 0x%x\n", &ME26_IOCINTTIMER() );
printf("SOFTIMER 0x%x\n", &ME26_IOCSOFTIMER() );
printf("USEINT 0x%x\n", &ME26_IOCUSEINTERRUPT() );
printf("NOINT 0x%x\n", &ME26_IOCNOINTERRUPT() );


for ($ch=0;$ch<16;$ch++) {
    $fh=sprintf("ADQ%02d",$ch);
    $nom=sprintf("</dev/me26.0.%02d",$ch);
    open ($fh,$nom)
	 or die "Cannot open $nom\n";
}

open(TIME,"</dev/me26.0.tim") or die "Cannot open me26.0.tim\n";



# Frequency in HZ
$frequency=1;
print "Frequency = $frequency\n";

$c0=int(sqrt(2e6/$frequency));
$c1=int(2e6/$c0/$frequency);

print "c0, c1 = $c0 ,  $c1\n";

$real_frequency=2e6/$c0/$c1;

print "Real frequency = $real_frequency\n";


$timer=pack('vv',($c0,$c1)); 
$ltimer=unpack('N',$timer);

print "ltimer = ",$ltimer,"\n";
#
## Making sure $ltimer is used as an integer */
$ltimer+=0;
ioctl(ADQ00,&ME26_IOCINTTIMER,$ltimer);

ioctl(ADQ00,&ME26_IOCUSEINTERRUPT,0);

    
for ($vez=0;$vez<5;$vez++) {

    for ($ch=0;$ch<16;$ch++) {
	  $fh=sprintf("ADQ%02d",$ch);
	  $bien=sysread($fh,$dato,2);
	  print "bytes read $bien\n";
	  $valor=unpack('S',$dato);
	  print "The value of channel $ch is $valor \n";
	  $bien=sysread(TIME,$dato,8);
	  print "Time bytes red $bien\n";
	  ($secs,$usecs)=unpack('ii',$dato);
	  print "seconds $secs  microsecs  $usecs\n";
    }

}









